/**
 *     __  ____                 _   __                
 *    /  |/  (_)_____________  / | / /___ _   ______ _
 *   / /|_/ / / ___/ ___/ __ \/  |/ / __ \ | / / __ `/
 *  / /  / / / /__/ /  / /_/ / /|  / /_/ / |/ / /_/ / 
 * /_/  /_/_/\___/_/   \____/_/ |_/\____/|___/\__,_/  
 *                                                  
 * NovaVGA Arduino Library
 * v 1.0 (10/20/2015)
 * Copyright (c) 2015 MicroNova, LLC
 * www.micro-nova.com
 * 
 * COLORS EXAMPLE
 * Demonstrates the 16-color CGA pallete.
 */

#include <SPI.h>
#include "NovaVGA.h"

// The SPI chip select pin, for Arduino UNO it is pin 10.
const int csPin = 10;

void setup() {
  // Setup VGA controller
  NovaVGA.init(csPin);
  NovaVGA.fillScreen(NovaVGA.Black);

  //     x y  w  h
  Rect r(0,0,10,10);
  NovaVGA.fillRect(r, NovaVGA.Black);
  NovaVGA.drawString("Black", r.left+r.width+3, r.top + 2, NovaVGA.White);

  r.top += r.height + 1;
  NovaVGA.fillRect(r, NovaVGA.Blue);
  NovaVGA.drawString("Blue", r.left+r.width+3, r.top + 2, NovaVGA.White);
  
  r.top += r.height + 1;
  NovaVGA.fillRect(r, NovaVGA.Green);
  NovaVGA.drawString("Green", r.left+r.width+3, r.top + 2, NovaVGA.White);

  r.top += r.height + 1;
  NovaVGA.fillRect(r, NovaVGA.Cyan);
  NovaVGA.drawString("Cyan", r.left+r.width+3, r.top + 2, NovaVGA.White);

  r.top += r.height + 1;
  NovaVGA.fillRect(r, NovaVGA.Red);
  NovaVGA.drawString("Red", r.left+r.width+3, r.top + 2, NovaVGA.White);

  r.top += r.height + 1;
  NovaVGA.fillRect(r, NovaVGA.Magenta);
  NovaVGA.drawString("Magenta", r.left+r.width+3, r.top + 2, NovaVGA.White);

  r.top += r.height + 1;
  NovaVGA.fillRect(r, NovaVGA.Brown);
  NovaVGA.drawString("Brown", r.left+r.width+3, r.top + 2, NovaVGA.White);

  r.top += r.height + 1;
  NovaVGA.fillRect(r, NovaVGA.LightGray);
  NovaVGA.drawString("LightGray", r.left+r.width+3, r.top + 2, NovaVGA.White);

  r.top += r.height + 1;
  NovaVGA.fillRect(r, NovaVGA.LightMagenta);
  NovaVGA.drawString("LightMagenta", r.left+r.width+3, r.top + 2, NovaVGA.White);

  r.top += r.height + 1;
  NovaVGA.fillRect(r, NovaVGA.LightBlue);
  NovaVGA.drawString("LightBlue", r.left+r.width+3, r.top + 2, NovaVGA.White);

  r.top += r.height + 1;
  NovaVGA.fillRect(r, NovaVGA.LightGreen);
  NovaVGA.drawString("LightGreen", r.left+r.width+3, r.top + 2, NovaVGA.White);


  r.left = 60;
  r.top = 0;
  NovaVGA.fillRect(r, NovaVGA.LightCyan);
  NovaVGA.drawString("LightCyan", r.left+r.width+3, r.top + 2, NovaVGA.White);

  r.top += r.height + 1;
  NovaVGA.fillRect(r, NovaVGA.LightRed);
  NovaVGA.drawString("LightRed", r.left+r.width+3, r.top + 2, NovaVGA.White);

  r.top += r.height + 1;
  NovaVGA.fillRect(r, NovaVGA.Yellow);
  NovaVGA.drawString("Yellow", r.left+r.width+3, r.top + 2, NovaVGA.White);

  r.top += r.height + 1;
  NovaVGA.fillRect(r, NovaVGA.Gray);
  NovaVGA.drawString("Gray", r.left+r.width+3, r.top + 2, NovaVGA.White);

  r.top += r.height + 1;
  NovaVGA.fillRect(r, NovaVGA.White);
  NovaVGA.drawString("White", r.left+r.width+3, r.top + 2, NovaVGA.White);


  // Draw a string with custom color
  // NovaVGA.drawString("Custom", 75, 68, 0b110101);
}

void loop() {
  // Do nothing
}
