/**
 *     __  ____                 _   __                
 *    /  |/  (_)_____________  / | / /___ _   ______ _
 *   / /|_/ / / ___/ ___/ __ \/  |/ / __ \ | / / __ `/
 *  / /  / / / /__/ /  / /_/ / /|  / /_/ / |/ / /_/ / 
 * /_/  /_/_/\___/_/   \____/_/ |_/\____/|___/\__,_/  
 *                                                  
 * NovaVGA Arduino Library
 * v 1.0 (10/20/2015)
 * Copyright (c) 2015 MicroNova, LLC
 * www.micro-nova.com
 * 
 * STRIPES EXAMPLE
 *
 * Draws stripes on the screen using the NovaVGA shield.
 */
 
#include "NovaVGAFast.h"

void setup() {
  // Setup VGA controller
  NovaVGA.init();
  
  // Draw vertical black and green stripes
  fillStripes(NovaVGA.Green, NovaVGA.Black, true);
}

void loop() {
  // Do nothing
}

void fillStripes(byte color1, byte color2, bool vertical)
{
  int w, h;
  for (h = 0; h < NovaVGA.SCREEN_HEIGHT; h++) {
    for (w = 0; w < NovaVGA.SCREEN_WIDTH; w++) {
      int high = vertical ? 0x01 & w : 0x01 & h;
      byte c = high ? color1 : color2;
      NovaVGA.writePixel(w, h, c);
    }
  }
}
